# coding: utf-8

"""
    VMware Aria Automation Pipelines APIs

    Aria Automation Pipelines is a continuous integration and continuous delivery (CICD) tool that you use to build Pipelines that model the software release process in your DevOps lifecycle. By creating Pipelines, you build the code infrastructure that delivers your software rapidly and continuously.  This page describes the RESTful APIs for Aria Automation Pipelines. The APIs facilitate CRUD operations on the various resources and entities used throughout Aria Automation Pipelines (Pipelines, Endpoints, Variables, etc.) and allow operations on them (executing a Pipeline, validating an Endpoint connection, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Aria Automation Pipelines entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/codestream/api/endpoints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/codestream/api/endpoints?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/codestream/api/endpoints?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /codestream/api/endpoints?$filter=startswith(name, 'ABC')     /codestream/api/endpoints?$filter=toupper(name) eq 'ABCD-JENKINS'     /codestream/api/endpoints?$filter=substringof(%27bc%27,tolower(name))     /codestream/api/endpoints?$filter=name eq 'ABCD' and project eq 'demo'   # noqa: E501

    OpenAPI spec version: 2019-10-17
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GitWebhookSpec(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'branch_name': 'str',
        'delay_time_in_mins': 'int',
        'description': 'str',
        'endpoint': 'str',
        'event_category': 'str',
        'exclusions': 'list[GitWebhookFileFilter]',
        'external_listener_link': 'str',
        'inclusions': 'list[GitWebhookFileFilter]',
        'input': 'object',
        'insecure_ssl': 'bool',
        'name': 'str',
        'pipeline': 'str',
        'prioritize_exclusion': 'bool',
        'project': 'str',
        'refresh_token': 'str',
        'repo_name': 'str',
        'secret_token': 'str',
        'server_type': 'str',
        'server_webhook_id': 'str'
    }

    attribute_map = {
        'branch_name': 'branchName',
        'delay_time_in_mins': 'delayTimeInMins',
        'description': 'description',
        'endpoint': 'endpoint',
        'event_category': 'eventCategory',
        'exclusions': 'exclusions',
        'external_listener_link': 'externalListenerLink',
        'inclusions': 'inclusions',
        'input': 'input',
        'insecure_ssl': 'insecureSsl',
        'name': 'name',
        'pipeline': 'pipeline',
        'prioritize_exclusion': 'prioritizeExclusion',
        'project': 'project',
        'refresh_token': 'refreshToken',
        'repo_name': 'repoName',
        'secret_token': 'secretToken',
        'server_type': 'serverType',
        'server_webhook_id': 'serverWebhookId'
    }

    def __init__(self, branch_name=None, delay_time_in_mins=None, description=None, endpoint=None, event_category=None, exclusions=None, external_listener_link=None, inclusions=None, input=None, insecure_ssl=None, name=None, pipeline=None, prioritize_exclusion=None, project=None, refresh_token=None, repo_name=None, secret_token=None, server_type=None, server_webhook_id=None):  # noqa: E501
        """GitWebhookSpec - a model defined in Swagger"""  # noqa: E501
        self._branch_name = None
        self._delay_time_in_mins = None
        self._description = None
        self._endpoint = None
        self._event_category = None
        self._exclusions = None
        self._external_listener_link = None
        self._inclusions = None
        self._input = None
        self._insecure_ssl = None
        self._name = None
        self._pipeline = None
        self._prioritize_exclusion = None
        self._project = None
        self._refresh_token = None
        self._repo_name = None
        self._secret_token = None
        self._server_type = None
        self._server_webhook_id = None
        self.discriminator = None
        if branch_name is not None:
            self.branch_name = branch_name
        if delay_time_in_mins is not None:
            self.delay_time_in_mins = delay_time_in_mins
        if description is not None:
            self.description = description
        if endpoint is not None:
            self.endpoint = endpoint
        if event_category is not None:
            self.event_category = event_category
        if exclusions is not None:
            self.exclusions = exclusions
        if external_listener_link is not None:
            self.external_listener_link = external_listener_link
        if inclusions is not None:
            self.inclusions = inclusions
        if input is not None:
            self.input = input
        if insecure_ssl is not None:
            self.insecure_ssl = insecure_ssl
        self.name = name
        if pipeline is not None:
            self.pipeline = pipeline
        if prioritize_exclusion is not None:
            self.prioritize_exclusion = prioritize_exclusion
        if project is not None:
            self.project = project
        if refresh_token is not None:
            self.refresh_token = refresh_token
        if repo_name is not None:
            self.repo_name = repo_name
        if secret_token is not None:
            self.secret_token = secret_token
        if server_type is not None:
            self.server_type = server_type
        if server_webhook_id is not None:
            self.server_webhook_id = server_webhook_id

    @property
    def branch_name(self):
        """Gets the branch_name of this GitWebhookSpec.  # noqa: E501

        Branch name for which the webhook has been configured.  # noqa: E501

        :return: The branch_name of this GitWebhookSpec.  # noqa: E501
        :rtype: str
        """
        return self._branch_name

    @branch_name.setter
    def branch_name(self, branch_name):
        """Sets the branch_name of this GitWebhookSpec.

        Branch name for which the webhook has been configured.  # noqa: E501

        :param branch_name: The branch_name of this GitWebhookSpec.  # noqa: E501
        :type: str
        """

        self._branch_name = branch_name

    @property
    def delay_time_in_mins(self):
        """Gets the delay_time_in_mins of this GitWebhookSpec.  # noqa: E501

        Delay time after which the pipeline execution is triggered.  # noqa: E501

        :return: The delay_time_in_mins of this GitWebhookSpec.  # noqa: E501
        :rtype: int
        """
        return self._delay_time_in_mins

    @delay_time_in_mins.setter
    def delay_time_in_mins(self, delay_time_in_mins):
        """Sets the delay_time_in_mins of this GitWebhookSpec.

        Delay time after which the pipeline execution is triggered.  # noqa: E501

        :param delay_time_in_mins: The delay_time_in_mins of this GitWebhookSpec.  # noqa: E501
        :type: int
        """

        self._delay_time_in_mins = delay_time_in_mins

    @property
    def description(self):
        """Gets the description of this GitWebhookSpec.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this GitWebhookSpec.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this GitWebhookSpec.

        A human-friendly description.  # noqa: E501

        :param description: The description of this GitWebhookSpec.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def endpoint(self):
        """Gets the endpoint of this GitWebhookSpec.  # noqa: E501

        Git endpoint.  # noqa: E501

        :return: The endpoint of this GitWebhookSpec.  # noqa: E501
        :rtype: str
        """
        return self._endpoint

    @endpoint.setter
    def endpoint(self, endpoint):
        """Sets the endpoint of this GitWebhookSpec.

        Git endpoint.  # noqa: E501

        :param endpoint: The endpoint of this GitWebhookSpec.  # noqa: E501
        :type: str
        """

        self._endpoint = endpoint

    @property
    def event_category(self):
        """Gets the event_category of this GitWebhookSpec.  # noqa: E501

        Git event type.  # noqa: E501

        :return: The event_category of this GitWebhookSpec.  # noqa: E501
        :rtype: str
        """
        return self._event_category

    @event_category.setter
    def event_category(self, event_category):
        """Sets the event_category of this GitWebhookSpec.

        Git event type.  # noqa: E501

        :param event_category: The event_category of this GitWebhookSpec.  # noqa: E501
        :type: str
        """

        self._event_category = event_category

    @property
    def exclusions(self):
        """Gets the exclusions of this GitWebhookSpec.  # noqa: E501

        Provide file exclusions as conditions for the trigger.  # noqa: E501

        :return: The exclusions of this GitWebhookSpec.  # noqa: E501
        :rtype: list[GitWebhookFileFilter]
        """
        return self._exclusions

    @exclusions.setter
    def exclusions(self, exclusions):
        """Sets the exclusions of this GitWebhookSpec.

        Provide file exclusions as conditions for the trigger.  # noqa: E501

        :param exclusions: The exclusions of this GitWebhookSpec.  # noqa: E501
        :type: list[GitWebhookFileFilter]
        """

        self._exclusions = exclusions

    @property
    def external_listener_link(self):
        """Gets the external_listener_link of this GitWebhookSpec.  # noqa: E501

        Git webhook listener link.  # noqa: E501

        :return: The external_listener_link of this GitWebhookSpec.  # noqa: E501
        :rtype: str
        """
        return self._external_listener_link

    @external_listener_link.setter
    def external_listener_link(self, external_listener_link):
        """Sets the external_listener_link of this GitWebhookSpec.

        Git webhook listener link.  # noqa: E501

        :param external_listener_link: The external_listener_link of this GitWebhookSpec.  # noqa: E501
        :type: str
        """

        self._external_listener_link = external_listener_link

    @property
    def inclusions(self):
        """Gets the inclusions of this GitWebhookSpec.  # noqa: E501

        Provide file inclusions as conditions for the trigger.  # noqa: E501

        :return: The inclusions of this GitWebhookSpec.  # noqa: E501
        :rtype: list[GitWebhookFileFilter]
        """
        return self._inclusions

    @inclusions.setter
    def inclusions(self, inclusions):
        """Sets the inclusions of this GitWebhookSpec.

        Provide file inclusions as conditions for the trigger.  # noqa: E501

        :param inclusions: The inclusions of this GitWebhookSpec.  # noqa: E501
        :type: list[GitWebhookFileFilter]
        """

        self._inclusions = inclusions

    @property
    def input(self):
        """Gets the input of this GitWebhookSpec.  # noqa: E501

        Pipeline Execution input properties.  # noqa: E501

        :return: The input of this GitWebhookSpec.  # noqa: E501
        :rtype: object
        """
        return self._input

    @input.setter
    def input(self, input):
        """Sets the input of this GitWebhookSpec.

        Pipeline Execution input properties.  # noqa: E501

        :param input: The input of this GitWebhookSpec.  # noqa: E501
        :type: object
        """

        self._input = input

    @property
    def insecure_ssl(self):
        """Gets the insecure_ssl of this GitWebhookSpec.  # noqa: E501

        verify SSL certificates when delivering payloads  # noqa: E501

        :return: The insecure_ssl of this GitWebhookSpec.  # noqa: E501
        :rtype: bool
        """
        return self._insecure_ssl

    @insecure_ssl.setter
    def insecure_ssl(self, insecure_ssl):
        """Sets the insecure_ssl of this GitWebhookSpec.

        verify SSL certificates when delivering payloads  # noqa: E501

        :param insecure_ssl: The insecure_ssl of this GitWebhookSpec.  # noqa: E501
        :type: bool
        """

        self._insecure_ssl = insecure_ssl

    @property
    def name(self):
        """Gets the name of this GitWebhookSpec.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option  # noqa: E501

        :return: The name of this GitWebhookSpec.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this GitWebhookSpec.

        A human-friendly name used as an identifier in APIs that support this option  # noqa: E501

        :param name: The name of this GitWebhookSpec.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def pipeline(self):
        """Gets the pipeline of this GitWebhookSpec.  # noqa: E501

        Pipeline name which is meant to be triggered when a git event occur.  # noqa: E501

        :return: The pipeline of this GitWebhookSpec.  # noqa: E501
        :rtype: str
        """
        return self._pipeline

    @pipeline.setter
    def pipeline(self, pipeline):
        """Sets the pipeline of this GitWebhookSpec.

        Pipeline name which is meant to be triggered when a git event occur.  # noqa: E501

        :param pipeline: The pipeline of this GitWebhookSpec.  # noqa: E501
        :type: str
        """

        self._pipeline = pipeline

    @property
    def prioritize_exclusion(self):
        """Gets the prioritize_exclusion of this GitWebhookSpec.  # noqa: E501

        Prioritize Exclusion ensures that pipelines are not triggered even if any ” +            “of the files in a commit match the specified files in the exclusion paths or regex.  # noqa: E501

        :return: The prioritize_exclusion of this GitWebhookSpec.  # noqa: E501
        :rtype: bool
        """
        return self._prioritize_exclusion

    @prioritize_exclusion.setter
    def prioritize_exclusion(self, prioritize_exclusion):
        """Sets the prioritize_exclusion of this GitWebhookSpec.

        Prioritize Exclusion ensures that pipelines are not triggered even if any ” +            “of the files in a commit match the specified files in the exclusion paths or regex.  # noqa: E501

        :param prioritize_exclusion: The prioritize_exclusion of this GitWebhookSpec.  # noqa: E501
        :type: bool
        """

        self._prioritize_exclusion = prioritize_exclusion

    @property
    def project(self):
        """Gets the project of this GitWebhookSpec.  # noqa: E501

        The project this entity belongs to.  # noqa: E501

        :return: The project of this GitWebhookSpec.  # noqa: E501
        :rtype: str
        """
        return self._project

    @project.setter
    def project(self, project):
        """Sets the project of this GitWebhookSpec.

        The project this entity belongs to.  # noqa: E501

        :param project: The project of this GitWebhookSpec.  # noqa: E501
        :type: str
        """

        self._project = project

    @property
    def refresh_token(self):
        """Gets the refresh_token of this GitWebhookSpec.  # noqa: E501

        Codestream API token.  # noqa: E501

        :return: The refresh_token of this GitWebhookSpec.  # noqa: E501
        :rtype: str
        """
        return self._refresh_token

    @refresh_token.setter
    def refresh_token(self, refresh_token):
        """Sets the refresh_token of this GitWebhookSpec.

        Codestream API token.  # noqa: E501

        :param refresh_token: The refresh_token of this GitWebhookSpec.  # noqa: E501
        :type: str
        """

        self._refresh_token = refresh_token

    @property
    def repo_name(self):
        """Gets the repo_name of this GitWebhookSpec.  # noqa: E501

        Repo name for which the webhook has been configured.  # noqa: E501

        :return: The repo_name of this GitWebhookSpec.  # noqa: E501
        :rtype: str
        """
        return self._repo_name

    @repo_name.setter
    def repo_name(self, repo_name):
        """Sets the repo_name of this GitWebhookSpec.

        Repo name for which the webhook has been configured.  # noqa: E501

        :param repo_name: The repo_name of this GitWebhookSpec.  # noqa: E501
        :type: str
        """

        self._repo_name = repo_name

    @property
    def secret_token(self):
        """Gets the secret_token of this GitWebhookSpec.  # noqa: E501

        Secret token to validate received payloads.  # noqa: E501

        :return: The secret_token of this GitWebhookSpec.  # noqa: E501
        :rtype: str
        """
        return self._secret_token

    @secret_token.setter
    def secret_token(self, secret_token):
        """Sets the secret_token of this GitWebhookSpec.

        Secret token to validate received payloads.  # noqa: E501

        :param secret_token: The secret_token of this GitWebhookSpec.  # noqa: E501
        :type: str
        """

        self._secret_token = secret_token

    @property
    def server_type(self):
        """Gets the server_type of this GitWebhookSpec.  # noqa: E501

        Git Server Type.  # noqa: E501

        :return: The server_type of this GitWebhookSpec.  # noqa: E501
        :rtype: str
        """
        return self._server_type

    @server_type.setter
    def server_type(self, server_type):
        """Sets the server_type of this GitWebhookSpec.

        Git Server Type.  # noqa: E501

        :param server_type: The server_type of this GitWebhookSpec.  # noqa: E501
        :type: str
        """

        self._server_type = server_type

    @property
    def server_webhook_id(self):
        """Gets the server_webhook_id of this GitWebhookSpec.  # noqa: E501

        Git webhook id.  # noqa: E501

        :return: The server_webhook_id of this GitWebhookSpec.  # noqa: E501
        :rtype: str
        """
        return self._server_webhook_id

    @server_webhook_id.setter
    def server_webhook_id(self, server_webhook_id):
        """Sets the server_webhook_id of this GitWebhookSpec.

        Git webhook id.  # noqa: E501

        :param server_webhook_id: The server_webhook_id of this GitWebhookSpec.  # noqa: E501
        :type: str
        """

        self._server_webhook_id = server_webhook_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GitWebhookSpec, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GitWebhookSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
